## jabberhandler for jabberif
##

from string import split,strip,join
import sys,os
import re
import jabber

class jabberhandler:
	def __init__(self, lh, uh, ph, config):
		self.__config = config
		self.__lh = lh
		self.__uh = uh
		self.__ph = ph ## only needed for the commandhandler
		
	def messageCB(self, con, msg):
		"""Called when a message is recieved"""
		if msg.getBody():
			msgbody = strip(msg.getBody())
			self.__lh.log('<' + str(msg.getFrom()) + '> ' + join(re.split('\r?\n', msgbody), '\n\t'), 'inmessage')
			if len(msgbody) > 0:
				if  msgbody[0] == '/':
					self.__ph.commandhandler({'con': con, 'msg': msg, 'cmd': re.split('[\s\t\r\n]+', msgbody[1:])})
				else:
					self.__ph.commandhandler({'con': con, 'msg': msg, 'cmd': ['msg', msgbody]})

	def presenceCB(self, con, prs):
		"""Called when a presence is recieved"""
		who = prs.getFrom()
		type = prs.getType()
		if type == None: type = 'available'

		elif type == 'unsubscribe':
			con.send(jabber.Presence(to=str(who), type='unsubscribed'))
			con.send(jabber.Presence(to=str(who), type='unsubscribe'))
		
		self.__uh.set_presence(who.getStripped(), str(who), type)


	def iqCB(self, con, iq):
		"""Called when an iq is recieved, we just let the library handle it at the moment"""
		pass

	def disconnectedCB(self, con):
		lh.log("Ouch, network error", 'error')
		## TODO: .. reconnect code missing here!
		raise Exception('unexpected disconnect')


	def connect(self):
		connection = 1
		if self.__config['ssl'] in ['1', 'on', 'yes']:
			connection = jabber.xmlstream.TCP_SSL
		self.con = jabber.Client(host=self.__config['server'], port=int(self.__config['port']), connection=connection)

		try:
			self.con.connect()
		except IOError, e:
			self.__lh.log("Couldn't connect: %s" % e, 'error')
			sys.exit(1)
		else:
			self.__lh.log("Connected",'connection')

		## handler registration
		self.con.registerHandler('message', self.messageCB)
		self.con.registerHandler('presence', self.presenceCB)
		self.con.registerHandler('iq', self.iqCB)
		self.con.setDisconnectHandler(self.disconnectedCB)


		## login
		self.__lh.log("Attempting to log in...", 'connection')

		if self.con.auth(self.__config['username'], self.__config['password'], self.__config['resource']):
			self.__lh.log("Logged in as %s to server %s" % ( self.__config['username'], self.__config['server']), 'connection')
		else:
			lg.log("eek -> %s %s" % (self.con.lastErr, self.con.lastErrCode), 'error')
			sys.exit(1)

		## roster/presence init
		self.__lh.log("Requesting Roster Info" , 'connection')
		self.con.requestRoster()
		self.con.sendInitPresence()

		self.JID = self.__config['username'] + '@' + self.__config['server'] + '/' + self.__config['resource']

