## userhandler for jabberif
##

import re

class userhandler:
	def __init__(self, config):
		self.userinfo = {}
		for op in re.split('[,\s\n\r]+', config['ops']):
			self.userinfo[op] = {'op': 1}
	
	def set_presence(self, id, jid, type):
		"""set presence of user with id and jid to type"""
		if not self.userinfo.has_key(id):
			self.userinfo[id] = {'presence': {}}
		elif not self.userinfo[id].has_key('presence'):
			self.userinfo[id]['presence'] = {}
		self.userinfo[id]['presence'][jid] = type
	
	def check_op(self, id):
		"""checks for op status"""
		if self.userinfo.has_key(id):
			if self.userinfo[id].has_key('op'):
				if self.userinfo[id]['op'] == 1:
					return 1
		return 0
	
	def get_presence(self, id):
		"""checks for presence"""
		if self.userinfo.has_key(id):
			if self.userinfo[id].has_key('presence'):
				return self.userinfo[id]['presence']
		return {}
	
	def get_all_users(self):
		"""return all cached users available"""
		return self.userinfo.keys()
