## template plugin for jabberif
##	this is a sample plugin to demonstrate the jabberif plugin api
##
## written by Ben Fuhrmannek <bef@erlangen.ccc.de>
##
##
## remark: have a look on security issues when taking arguments from commands
##

import sys

class template_plugin:
	def __init__(self, ph):
		## ph is the plugin handler
		self.ph = ph
		self.name = 'template_plugin'

		## register command showargs
		ph.register_command(self, 'showargs', self.showargs, 'show arguments')

		## register op-access-only command
		ph.register_command(self, 'blabla', self.whatever, 'secret discovery', {'op_only':1})

		## maybe we handle all messages without '/' prefix
		#ph.register_command(self, 'msg', self.msghandler, 'all other messages go here')

	def showargs(self, args):
		## convert arguments to string
		output = str(args)

		## send output back to sender
		self.ph.send_back(args['con'], args['msg'], '\n'+output)
		
	def whatever(self, args):
		## module access
		modules = self.ph.plugins()
		
		## command access
		commands = self.ph.commands()
		
		## userhandler access
		uh = self.ph.get_userhandler()
		
		## parameter access
		params = args['cmd'][1:]

		## do sth. important
		## ...
		
		## send msg back to sender
		self.ph.send_back(args['con'], args['msg'], 'the answer is 42')

